/*
 * $Id: RecursionTest.java 9 2007-02-06 18:20:13Z max $
 * 
 * Copyright (c) 2006-2007 Maximilian Antoni. All rights reserved.
 * 
 * This software is licensed as described in the file LICENSE.txt, which you
 * should have received as part of this distribution. The terms are also
 * available at http://www.maxantoni.de/projects/eva-properties/license.txt.
 */
package com.eva.properties;

import java.io.IOException;
import java.util.Map;

import junit.framework.TestCase;

/**
 * @author Max Antoni
 * @version $Revision: 9 $
 */
public class RecursionTest extends TestCase {

    public void testSimple() throws IOException {
        // Enable properties debugging for this:
        PropertiesFactory.DEBUG = true;
        
        Map properties = PropertiesFactory.createMap(
                "classpath://com/eva/properties/recursion.eva");
        try {
            properties.get("foo");
            fail("PropertiesException expected.");
        }
        catch(PropertiesException e) {
            assertEquals("Cannot resolve \"foo\", Cannot replace ${bar}, "
                    + "Cannot replace ${foo}, Recursive references: "
                    + "foo > bar > foo", e.getMessage());
        }
        assertTrue(true);
    }

}
